workshop12/poll_application/poll/urls.py
from django.urls import path

from poll.views import HomeView, QuestionCreateView, QuestionDetailView, QuestionDeleteView, QuestionUpdateView

urlpatterns = [
    path('', HomeView.as_view(), name='home'),
    path('question/create/', QuestionCreateView.as_view(), name='question-create'),
    path('questions/<int:pk>/', QuestionDetailView.as_view(), name='question-detail'),
    path('questions/<int:pk>/delete/', QuestionDeleteView.as_view(), name='question-delete'),
    path('questions/<int:pk>/update/', QuestionUpdateView.as_view(), name='question-update'),
]

workshop12/poll_application/poll_application/urls.py
from django.contrib import admin
from django.urls import path, include


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('poll.urls'))
]

workshop12/poll_application/poll/models.py
from django.db import models
from django.utils.translation import gettext_lazy as _


class Question(models.Model):
    class Meta:
        verbose_name = _('Question')
        verbose_name_plural = _('Questions')


    text = models.CharField(max_length=200, null=False)
    create_date = models.DateTimeField(auto_now_add=True)

    def __str__(self) -> str:
        return str(self.text)



class Option(models.Model):
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    text = models.CharField(max_length=200)
    votes = models.PositiveIntegerField(default=0)

    def __str__(self) -> str:
        return f'{self.question.text} - {self.text}'

workshop12/poll_application/poll/forms.py
from django import forms
from poll.models import Question


class QuestionCreateForm(forms.ModelForm):
    class Meta:
        model = Question
        fields = ['text']

workshop12/poll_application/poll/views.py
from django.forms import BaseModelForm
from django.shortcuts import render, redirect
from django.urls import reverse_lazy, reverse
from django.http import HttpResponse, HttpRequest
from django.views.generic import CreateView, ListView, DetailView, UpdateView, DeleteView
from poll.models import Question
from poll.forms import QuestionCreateForm



def home_view(request: HttpRequest) -> HttpResponse:
    return render(
        request,
        'home.html',
        {
            'questions': Question.objects.all()
        }
    )

def question_create_view(request: HttpRequest) -> HttpResponse:
    form = QuestionCreateForm()
    if request.method == 'POST':
        form = QuestionCreateForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect('home')

    
    print(f'METHOD: {request.method}')
    print(f'POST: {request.POST}')
    print(f'GET: {request.GET}')
    return render(
        request,
        'question_create.html',
        {
            'form': form
        }
    )


class HomeView(ListView):
    model = Question
    template_name = 'home.html'
    context_object_name = 'questions'
    paginate_by = 20


class QuestionCreateView(CreateView):
    model = Question
    fields = '__all__'
    template_name = 'question_create.html'
    success_url = reverse_lazy('home')

    def form_valid(self, form: BaseModelForm) -> HttpResponse:
        self.object = form.save(commit=False)
        self.object.text += "Changed text"
        self.object.save()
        print(self.object.text)
        return redirect(self.success_url)


class QuestionDetailView(DetailView):
    model = Question
    template_name = 'question_detail.html'


class QuestionDeleteView(DeleteView):
    model = Question
    template_name = 'question_delete.html'
    success_url = reverse_lazy('home')


class QuestionUpdateView(UpdateView):
    model = Question
    fields = '__all__'
    template_name = 'question_create.html'

    def get_success_url(self) -> str:
        return reverse('question-detail', kwargs={'pk': self.object.pk})

workshop12/poll_application/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=viewport, initial-scale=1.0">
    <title>Poll Website</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-QWTKZyjpPEjISv5WaRU9OFeRpok6YctnYmDr5pNlyT2bRjXh0JMhjY6hW+ALEwIH" crossorigin="anonymous">

</head>
<body>  
    <nav>
        <ul>
            <li><a href="{% url 'home' %}">Home</a></li>
            <li><a href="{% url 'question-create' %}">Create Question</a></li>
        </ul>
    </nav>
    {% block content %}{% endblock %}
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.11.8/dist/umd/popper.min.js" integrity="sha384-I7E8VVD/ismYTF4hNIPjVp/Zjvgyol6VFvRkX/vR+Vc4jQkC+hVqc2pM8ODewa9r" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.min.js" integrity="sha384-0pUGZvbkm6XF6gxjEnlmuGrJXVbNuzT9qBBavbLwCsOGabYfZo0T0to5eqruptLy" crossorigin="anonymous"></script>
</body>
</html>

workshop12/poll_application/templates/home.html
{% extends 'base.html' %}

{% block content %}
    <h1>Hi there from Template</h1>

    {% for question in questions %}
        <div>
            <h2><a href="{% url 'question-detail' question.pk %}">{{ question.text }}</a></h2>
            <button class="btn btn-warning"><a class="text-decoration-none text-white" href="{% url 'question-update' question.pk %}">Update</a></button>
            <button class="btn btn-danger"><a class="text-decoration-none text-white" href="{% url 'question-delete' question.pk %}">Delete</a></button>
            <ul>
                {% for option in question.option_set.all %}
                    <li>
                        {{ option.text }} has {{ option.votes }} votes
                    </li>
                {% endfor %}
            </ul>
        </div>
    {% endfor %}

    <div class="mx-auto text-center">
        {% for page_number in page_obj.paginator.get_elided_page_range %}
          {% if page_number == page_obj.paginator.ELLIPSIS %}
              {{ page_number }}
          {% else %}
              <a
                      href="{% url 'home' %}?page={{ page_number }}&q={{ request.GET.q }}"
                      class="{% if page_number == page_obj.number %}current{% endif %} btn btn-primary    "
              >
                  {{ page_number }}
              </a>
          {% endif %}
        {% endfor %}
    </div>
{% endblock %}

workshop12/poll_application/templates/question_create.html
{% extends 'base.html' %}

{% block content %}
    <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <button>Submit</button>
    </form>
{% endblock %}

workshop12/poll_application/templates/question_delete.html
{% extends 'base.html' %}

{% block content %}
    <form method="post">
        {% csrf_token %}
        <h1>Are you sure you want to delete this question?</h1>
        <h2>{{ question.text }}</h2>
        <a href="{% url 'home' %}" class="btn btn-primary">Cancel</a>
        <button class="btn btn-danger">Delete</button>
    </form>
{% endblock %}

workshop12/poll_application/templates/question_detail.html
{% extends 'base.html' %}

{% block content %}
    <h1>{{ question.text }}</h1>

    <form method="post">
        {% csrf_token %}
        {% for option in question.option_set.all %}
            <div>
                <input type="radio" name="option" id="option{{ option.id }}" value="{{ option.id }}">
                <label for="option{{ option.id }}">{{ option.text }}</label>
            </div>
        {% endfor %}
        <button>Submit</button>
    </form>
{% endblock %}